package com.jiuqi.util.biff;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.jiuqi.util.Stream;
import com.jiuqi.util.StreamException;
import com.jiuqi.util.biff.BIFFFiler;
import java.util.Date;

public class BIFFWriter extends BIFFFiler {
  public BIFFWriter() {}
  
  public BIFFWriter(Stream stream) {
    super(stream);
  }
  
  public void write() throws StreamException {
    this.stream.write(this.biff.getSign());
    this.stream.writeInt(this.biff.getSize());
    this.stream.copyFrom(this.biff.getData(), 0L);
  }
  
  public void write(byte sign) throws StreamException {
    this.biff.reset(sign);
    write();
  }
  
  public void write(byte sign, int value) throws StreamException {
    this.biff.reset(sign);
    this.biff.getData().writeInt(value);
    write();
  }
  
  public void write(byte sign, double value) throws StreamException {
    this.biff.reset(sign);
    this.biff.getData().writeDouble(value);
    write();
  }
  
  public void write(byte sign, String value) throws StreamException {
    this.biff.reset(sign);
    if (value != null)
      this.biff.getData().writeString(value); 
    write();
  }
  
  public void write(byte sign, boolean value) throws StreamException {
    this.biff.reset(sign);
    this.biff.getData().writeBool(value);
    write();
  }
  
  public void write(byte sign, long value) throws StreamException {
    this.biff.reset(sign);
    this.biff.getData().writeLong(value);
    write();
  }
  
  public void write(byte sign, Date value) throws StreamException {
    this.biff.reset(sign);
    this.biff.getData().writeLong(value.getTime());
    write();
  }
  
  public void write(byte sign, byte[] value) throws StreamException {
    this.biff.reset(sign);
    this.biff.getData().writeBuffer(value, 0, value.length);
    write();
  }
  
  public void writeEOF() throws StreamException {
    write(this.eofSign);
  }
}
